# - Locate TMDLib library
# in a directory defined via  TMDLIB_ROOT_DIR or TMDLIB_DIR.
# Defines:
#
#  TMDLIB_FOUND
#  TMDLIB_INCLUDE_DIR
#  TMDLIB_INCLUDE_DIRS (not cached)
#  TMDLIB_LIBRARIES
if (TMDLIB_ROOT_DIR OR TMDLIB_DIR OR (DEFINED ENV{TMDLIB_ROOT_DIR}) OR (DEFINED ENV{TMDLIB_DIR}) )
  set(TMDLIB_SEARCH_DIRS "" CACHE STRING "" FORCE)
  if (TMDLIB_ROOT_DIR)
    list (APPEND TMDLIB_SEARCH_DIRS "${TMDLIB_ROOT_DIR}" )
  endif()
  if (TMDLIB_DIR)
    list (APPEND TMDLIB_SEARCH_DIRS "${TMDLIB_DIR}" )
  endif()
  if (DEFINED EVN{TMDLIB_ROOT_DIR})
    list (APPEND TMDLIB_SEARCH_DIRS "$ENV{TMDLIB_ROOT_DIR}" )
  endif()
  if (DEFINED ENV{TMDLIB_DIR})
    list (APPEND TMDLIB_SEARCH_DIRS "ENV{TMDLIB_DIR}" )
  endif()
endif()

if (TMDLIB_SEARCH_DIRS)
  find_path(TMDLIB_INCLUDE_DIR tmdlib/TMDlib.h PATHS ${TMDLIB_SEARCH_DIRS} PATH_SUFFIXES include NO_DEFAULT_PATH)
  find_library(TMDLIB_TMDlib_LIBRARY NAMES TMDlib PATHS ${TMDLIB_SEARCH_DIRS}  PATH_SUFFIXES lib lib64 NO_DEFAULT_PATH)
  find_library(TMDLIB_apfelxx_LIBRARY NAMES apfelxx PATHS ${TMDLIB_SEARCH_DIRS}  PATH_SUFFIXES lib lib64 NO_DEFAULT_PATH)
else()
  find_path(TMDLIB_INCLUDE_DIR tmdlib/TMDlib.h PATH_SUFFIXES include)
  find_library(TMDLIB_TMDlib_LIBRARY NAMES TMDlib PATHS_SUFFIXES lib lib64)
  find_library(TMDLIB_apfelxx_LIBRARY NAMES apfelxx PATHS_SUFFIXES lib lib64)
endif()

set(TMDLIB_VERSION 0.0.0)
if (TMDLIB_INCLUDE_DIR)
  if (EXISTS ${TMDLIB_INCLUDE_DIR}/../bin/TMDlib-config)
    file(STRINGS ${TMDLIB_INCLUDE_DIR}/../bin/TMDlib-config TMDLIB_VERSION_STRING_CONTENT REGEX "^test.*OUT [1234567890\.]*\"")
    string(REGEX MATCH "[1234567890\.]+[a-zA-Z]*" TMDLIB_VERSION ${TMDLIB_VERSION_STRING_CONTENT})
  endif()
endif()

if (TMDLIB_TMDlib_LIBRARY AND TMDLIB_apfelxx_LIBRARY)
  set(TMDLIB_LIBRARIES ${TMDLIB_TMDlib_LIBRARY} ${TMDLIB_apfelxx_LIBRARY})
endif()

set(TMDLIB_INCLUDE_DIRS ${TMDLIB_INCLUDE_DIR})

# handle the QUIETLY and REQUIRED arguments and set TMDLIB_FOUND to TRUE if
# all listed variables are TRUE

INCLUDE(FindPackageHandleStandardArgs)

FIND_PACKAGE_HANDLE_STANDARD_ARGS(TMDLIB FOUND_VAR TMDLIB_FOUND REQUIRED_VARS TMDLIB_INCLUDE_DIR TMDLIB_LIBRARIES TMDLIB_VERSION HANDLE_COMPONENTS)

mark_as_advanced(TMDLIB_FOUND TMDLIB_INCLUDE_DIRS TMDLIB_LIBRARIES)
